<?php

/**
 * Created by PhpStorm.
 * User: wangchen
 * Date: 2019-05-07
 * Time: 14:48
 */

namespace App\Cache;


class CacheKeys
{
    /**
     * 所有key的管理配置
     *
     * key规范：类型+模块+功能+参数
     *
     * H:   表示Hash类型
     * Ss:  表示SortedSet类型
     * S:   表示Set集合
     * L:   表示List类型
     * Str: 表示String类型
     *
     * @var array
     */
    public static $all = [
        'user'      => [
            'token'           => 'u_token_%s',                    // %s为token值
            'recent_books'    => 'u_recent_books_%s',             // 最近阅读书籍(%s为uid)
            'current_chapter' => 'u_current_book_and_chapter_%s', // 当前阅读章节(%s为uid)
            'share_num'       => 'u_share_book_%s',               // 每日分享数(%s为uid)
        ],
        'statistic' => [
            'subscribe_books'           => 's_subscribe_books_%s',  // 书籍订阅统计(%s为日期Ymd)
            'charge_list_pv'            => 's_charge_list_pv_%s',   // 充值档位的pv(%s为日期Ymd)
            'charge_list_uv'            => 's_charge_list_uv_%s',   // 充值档位的uv(%s为日期Ymd)
            'template_uv'               => 's_template_uv_%s',      // 充值模板的uv(%s为模板id)
            'add_shelf_pv'              => 'add_shelf_pv_%s',       // 加入书架的pv(%s为日期Ymd)
            'add_shelf_uv'              => 'add_shelf_uv_%s',       // 加入书架的uv(%s为日期Ymd)
            'set_url_link_pv'           => 'set_url_link_pv_%s',    // 生成分享链接参数的pv(%s为日期Ymd)
            'set_url_link_uv'           => 'set_url_link_uv_%s',    // 生成分享链接参数的uv(%s为日期Ymd)
            'set_dy_link_uv'            => 'set_dy_link_uv_%s',     // 生成外网分享链接的uv(%s为日期Ymd)
            'set_dy_link_pv'            => 'set_dy_link_pv_%s',     // 生成外网分享链接的uv(%s为日期Ymd)
            'welfare_pv'                => 'welfare_pv_%s',         // 福利页的pv(%s为日期Ymd)
            'welfare_uv'                => 'welfare_uv_%s',         // 福利页的uv(%s为日期Ymd)
            'book_list_pv'              => 'book_list_pv_%s',       // 书籍搜索页的pv(%s为日期Ymd)
            'book_list_uv'              => 'book_list_uv_%s',       // 书籍搜索页的uv(%s为日期Ymd)
        ],
		'finance'   => [
            'sms_code'  => 'dy_sms_%s_%s',        // channelId phone
            'with_draw' => 'dy_withdraw_cash:%s', // date('Ymd')
        ],
    ];
}
