<?php

namespace App\Http\Controllers\DeepSeek;

use App\Facade\Site;
use App\Consts\ErrorConst;
use App\Exceptions\ApiException;
use App\Libs\ApiResponse;
use App\Libs\Utils;
use App\Services\DeepSeek\DeepSeekService;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Support\Facades\Redis;
use Illuminate\Support\Facades\Validator;

class DeepSeekController extends BaseController
{
    use ApiResponse;
    protected $deepseekService;

    public function __construct(
        DeepSeekService $deepseekService
    ) {
        $this->deepseekService = $deepseekService;
    }

    /**
     * 可选供应商
     *
     * @param Request $request
     * @return mixed
     */
    public function chatWithReasoner(Request $request) {
        $data = $request->all();
        $result = $this->deepseekService->chatWithReasoner($data);
        return $this->success($result);
    }

    /**
     * 音色列表
     *
     * @param Request $request
     * @return mixed
     */
    public function timbreList(Request $request) {
        $data = $request->all();
        $result = $this->deepseekService->timbreList($data);
        return $this->success($result);
    }

    /**
     * 新增合成任务
     *
     * @param Request $request
     * @return mixed
     */
    public function addGenerateTask(Request $request) {
        $data = $request->all();
        $result = $this->deepseekService->addGenerateTask($data);
        return $this->success(['success'=>$result ? 1 : 0]);
    }

    // 获取火山临时token
    public function setStsToken(Request $request) {
        $data = $request->all();
        $result = $this->deepseekService->setStsToken($data);
        return $this->success($result);
    }
}
