<?php

namespace App\Http\Controllers\Timbre;

use App\Facade\Site;
use App\Consts\ErrorConst;
use App\Exceptions\ApiException;
use App\Libs\ApiResponse;
use App\Libs\Utils;
use App\Services\Timbre\TimbreService;
use App\Transformer\Timbre\TimbreTransformer;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Support\Facades\Redis;
use Illuminate\Support\Facades\Validator;

class TimbreController extends BaseController
{
    use ApiResponse;
    protected $timbreService;

    public function __construct(
        TimbreService $timbreService
    ) {
        $this->timbreService = $timbreService;
    }

    public function categoryList(Request $request) {
        $data = $request->all();
        $result = $this->timbreService->getCategoryList($data);
        return $this->success($result, [new TimbreTransformer(), 'newBuildCategoryList']);
    }

    /**
     * 音色列表
     *
     * @param Request $request
     * @return mixed
     */
    public function timbreList(Request $request) {
        $data = $request->all();
        $result = $this->timbreService->getTimbreList($data);
        return $this->success($result, [new TimbreTransformer(), 'newBuildTimbreList']);
    }

    /**
     * 可选书籍
     *
     * @param Request $request
     * @return mixed
     */
    public function allBooks(Request $request) {
        $data = $request->all();
        $result = $this->timbreService->getAllBooks($data);
        return $this->success($result);
    }

    // 编辑音色
    public function editTimbre(Request $request) {
        $data = $request->all();
        $result = $this->timbreService->editTimbre($data);
        return $this->success(['success' => $result ? 1 : 0]);
    }
}
