<?php

namespace App\Providers;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\ServiceProvider;
use Illuminate\Http\Request;

class SQLServiceProvider extends ServiceProvider
{
    /**
     * Bootstrap the application services.
     * Request
     * @return void
     */
    public function boot(Request $request)
    {
        DB::listen(function ($query) use($request) {
                try{
                    $sql_mode = str_replace('?','%s',$query->sql);
//                   $sql = vsprintf($sql_mode,$query->bindings);
//                   Log::info('TIME:'.$query->time.'--SQL:'.$sql.'----route:'.$request->url());
                }catch (\Exception $e){
                    Log::info($e);
                }
        });
    }

    /**
     * Register the application services.
     *
     * @return void
     */
    public function register()
    {
        //
    }
}
